
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class ProjectsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const projects = await db.projects.create(
            {
                id: data.id || undefined,
        
        title: data.title
        ||
        null
            ,
            
        slug: data.slug
        ||
        null
            ,
            
        summary: data.summary
        ||
        null
            ,
            
        description: data.description
        ||
        null
            ,
            
        location_text: data.location_text
        ||
        null
            ,
            
        start_date: data.start_date
        ||
        null
            ,
            
        end_date: data.end_date
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        is_featured: data.is_featured
        ||
        false
        
            ,
            
        is_published: data.is_published
        ||
        false
        
            ,
            
        sort_order: data.sort_order
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        

        
        await projects.setServices(data.services || [], {
            transaction,
        });
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.projects.getTableName(),
                belongsToColumn: 'cover_images',
                belongsToId: projects.id,
            },
            data.cover_images,
            options,
        );
        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.projects.getTableName(),
                belongsToColumn: 'before_images',
                belongsToId: projects.id,
            },
            data.before_images,
            options,
        );
        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.projects.getTableName(),
                belongsToColumn: 'after_images',
                belongsToId: projects.id,
            },
            data.after_images,
            options,
        );
        

        return projects;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const projectsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                title: item.title
            ||
            null
            ,
            
                slug: item.slug
            ||
            null
            ,
            
                summary: item.summary
            ||
            null
            ,
            
                description: item.description
            ||
            null
            ,
            
                location_text: item.location_text
            ||
            null
            ,
            
                start_date: item.start_date
            ||
            null
            ,
            
                end_date: item.end_date
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                is_featured: item.is_featured
            ||
            false
        
            ,
            
                is_published: item.is_published
            ||
            false
        
            ,
            
                sort_order: item.sort_order
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const projects = await db.projects.bulkCreate(projectsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < projects.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.projects.getTableName(),
                    belongsToColumn: 'cover_images',
                    belongsToId: projects[i].id,
                },
                data[i].cover_images,
                options,
            );
        }
        
        for (let i = 0; i < projects.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.projects.getTableName(),
                    belongsToColumn: 'before_images',
                    belongsToId: projects[i].id,
                },
                data[i].before_images,
                options,
            );
        }
        
        for (let i = 0; i < projects.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.projects.getTableName(),
                    belongsToColumn: 'after_images',
                    belongsToId: projects[i].id,
                },
                data[i].after_images,
                options,
            );
        }
        

        return projects;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const projects = await db.projects.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.title !== undefined) updatePayload.title = data.title;
        
        
        if (data.slug !== undefined) updatePayload.slug = data.slug;
        
        
        if (data.summary !== undefined) updatePayload.summary = data.summary;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        if (data.location_text !== undefined) updatePayload.location_text = data.location_text;
        
        
        if (data.start_date !== undefined) updatePayload.start_date = data.start_date;
        
        
        if (data.end_date !== undefined) updatePayload.end_date = data.end_date;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.is_featured !== undefined) updatePayload.is_featured = data.is_featured;
        
        
        if (data.is_published !== undefined) updatePayload.is_published = data.is_published;
        
        
        if (data.sort_order !== undefined) updatePayload.sort_order = data.sort_order;
        
        
        updatePayload.updatedById = currentUser.id;

        await projects.update(updatePayload, {transaction});

        
        

        
        
        if (data.services !== undefined) {
            await projects.setServices(data.services, { transaction });
        }
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.projects.getTableName(),
                belongsToColumn: 'cover_images',
                belongsToId: projects.id,
            },
            data.cover_images,
            options,
        );
        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.projects.getTableName(),
                belongsToColumn: 'before_images',
                belongsToId: projects.id,
            },
            data.before_images,
            options,
        );
        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.projects.getTableName(),
                belongsToColumn: 'after_images',
                belongsToId: projects.id,
            },
            data.after_images,
            options,
        );
        

        return projects;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const projects = await db.projects.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of projects) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of projects) {
                await record.destroy({transaction});
            }
        });


        return projects;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const projects = await db.projects.findByPk(id, options);

        await projects.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await projects.destroy({
            transaction
        });

        return projects;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const projects = await db.projects.findOne(
            { where },
            { transaction },
        );

        if (!projects) {
            return projects;
        }

        const output = projects.get({plain: true});

        
        
        
        
        
        
        
        
        
        output.testimonials_project = await projects.getTestimonials_project({
            transaction
        });
        
        
        
        output.leads_project = await projects.getLeads_project({
            transaction
        });
        
        
        output.media_assets_project = await projects.getMedia_assets_project({
            transaction
        });
        
        
        
        
        output.cover_images = await projects.getCover_images({
            transaction
        });
        
        
        output.before_images = await projects.getBefore_images({
            transaction
        });
        
        
        output.after_images = await projects.getAfter_images({
            transaction
        });
        
        
        output.services = await projects.getServices({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [


      {
        model: db.services,
        as: 'services',
        required: false,
      },


      {
        model: db.file,
        as: 'cover_images',
      },

      {
        model: db.file,
        as: 'before_images',
      },

      {
        model: db.file,
        as: 'after_images',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.title) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'projects',
                        'title',
                        filter.title,
                    ),
                };
            }
            
            if (filter.slug) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'projects',
                        'slug',
                        filter.slug,
                    ),
                };
            }
            
            if (filter.summary) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'projects',
                        'summary',
                        filter.summary,
                    ),
                };
            }
            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'projects',
                        'description',
                        filter.description,
                    ),
                };
            }
            
            if (filter.location_text) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'projects',
                        'location_text',
                        filter.location_text,
                    ),
                };
            }
            

            
            
            if (filter.calendarStart && filter.calendarEnd) {
                where = {
                    ...where,
                    [Op.or]: [
                        {
                            start_date: {
                                [Op.between]: [filter.calendarStart, filter.calendarEnd],
                            },
                    },
                {
                    end_date: {
                        [Op.between]: [filter.calendarStart, filter.calendarEnd],
                    },
                },
                ],
            };
            }
            

            
            if (filter.start_dateRange) {
                const [start, end] = filter.start_dateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    start_date: {
                    ...where.start_date,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    start_date: {
                    ...where.start_date,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.end_dateRange) {
                const [start, end] = filter.end_dateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    end_date: {
                    ...where.end_date,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    end_date: {
                    ...where.end_date,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.sort_orderRange) {
                const [start, end] = filter.sort_orderRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    sort_order: {
                    ...where.sort_order,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    sort_order: {
                    ...where.sort_order,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            
            if (filter.is_featured) {
                where = {
                    ...where,
                is_featured: filter.is_featured,
            };
            }
            
            if (filter.is_published) {
                where = {
                    ...where,
                is_published: filter.is_published,
            };
            }
            



      if (filter.services) {
        const searchTerms = filter.services.split('|');

        include = [
          {
            model: db.services,
            as: 'services_filter',
            required: searchTerms.length > 0,
            where: searchTerms.length > 0 ? {
              [Op.or]: [
                { id: { [Op.in]: searchTerms.map(term => Utils.uuid(term)) } },
                { 
                  name: {
                    [Op.or]: searchTerms.map(term => ({ [Op.iLike]: `%${term}%` }))
                  }
                }
              ]
            } : undefined
          },
          ...include,
        ]
      }


            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.projects.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'projects',
                        'title',
                        query,
                    ),
                ],
            };
        }

        const records = await db.projects.findAll({
            attributes: [ 'id', 'title' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['title', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.title,
        }));
    }

    
};

